﻿/*

 Made By Sylvain Robert 2004-01-23
 Modified for MiniGUI by Grigory Filatov 2007-10-26
 Modified for Hmg by Mustafa López & el Rateret del Culebrón-Xinorlet 2018

*/

#include <minigui.ch>
#include <hmg_BoxLetterShow.ch>
#include <Viewry.prg>
#include <About.prg>

#command COMPRESS [ FILES ] <afiles> ;
		TO <zipfile>  ;
		BLOCK <block> ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ LEVEL <level> ] ;
		[ <ovr: OVERWRITE> ] ;
		[ PASSWORD <password> ] ;
		[ <srp: STOREPATH> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_ZipFile( <zipfile> , <afiles> , <level> , <block> , <.ovr.> , <password> , <.srp.> , , <fileblock> )

#command UNCOMPRESS [ FILE ] <zipfile> ;
		[ EXTRACTPATH <extractpath> ] ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ BLOCK <block> ] ;
		[ <createdir: CREATEDIR> ] ;
		[ PASSWORD <password> ] ;
		[ <dummy1: FILEMASK, FILEARRAY> <mask> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_UnZipFile( <zipfile> , <block> , <.createdir.> , <password> , <extractpath> , <mask> , <fileblock> )

*------------------------------------------------------------------------------*
FUNCTION Main
*------------------------------------------------------------------------------*
  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET CODEPAGE TO UNICODE
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET TOOLTIPSTYLE BALLOON
  SET PATH TO  HB_Curdrive()+":\"+Rtrim(Curdir() )
*----------------------------------*
  CLOSE DATABASES

  rNum := "0000000000"   

  PUBLIC  Tipx  := "*.*"
  PUBLIC  TipxX := "*.*"

  PUBLIC  nPos , cFile , lShowFileName 
  PUBLIC  aFiles, cDir, cPath

  PRIVATE HORAq  := RIGHT(TIME(), 4)                && <--------- Separa por Atras    
  PRIVATE HORAx  := STRTRAN(HORAq, ':')             && <--------- Eliminas los dos puntos(:) 
  PRIVATE dirax  := RIGHT( HORAx, 2) 
 
  PRIVATE Strin  := DTOC(DATE())
  PRIVATE Dchar  := DTOS(CTOD(Strin))
  PRIVATE cArya  := RIGHT( Dchar,1 ) + STRTRAN(TIME(),':') 
  PRIVATE pRova  := HORAx + cArya 
  PRIVATE pQrix  := STUFF( pRova , 1, 1, "8")    
  PRIVATE mirgy  := SUBSTR( pRova, 1, 1)    
 
*--------------------------------------------------------------*

  PRIVATE aDir1W  :=  HB_Curdrive()+":\"+Rtrim(Curdir() ) 
  PRIVATE DirXY   :="Compress_Zip\" 
  PRIVATE DirZY   :="UnCompress_Zip\" 

  PRIVATE cFileD , aDir , cPath  , ficXq  , aFiles 
  PRIVATE nLen   , Typo , firaax , NuevoT
  PRIVATE FDIA   , FDIAx ,HORA   , HORAx  ,HORYx , HORy 
  PRIVATE Date_Copy  , Nome_Zip , AdireQ , rNum          
  PRIVATE nDirElemNo , aChecboQ  
  PRIVATE FicherA , Nuevo , mtable , passy , cCPass   

*-----------------------------------------------------------------*
 IF ! HB_DirExists( DirXY)
     DirMake( DirXY )
 ENDIF
 IF ! HB_DirExists( DirZY)
     DirMake( DirZY )
 ENDIF 
*-----------------------------------------------------------------*    
IF ! FILE("CONTROL.DBF")
     NoEstaDBF()
ELSE
    CLOSE DATABASES
    SELECT 1   
    USE CONTROL NEW
    INDEX ON DATE_E TO Segury   
ENDIF
*-----------------------------------------------------------------*    

  DEFINE WINDOW Form_1           ;
	AT 0, 0                  ;
	WIDTH 405 HEIGHT 415     ; 
	TITLE "HB_Zip_ProgressBar New" ;
	ICON "Logo"              ;
        BACKCOLOR {128,128,255}  ;  
	MAIN NOMAXIMIZE NOSIZE   ;
	FONT "Arial" SIZE 9

        ON KEY ESCAPE ACTION  Form_1.Release

        DEFINE TIMER Timer_1 INTERVAL 1000  ACTION (RELEASE MEMORY)
   
        DEFINE TIMER Timer_2 ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 130, thisWindow.Col := 480 }   

        MiFrame( 025,020,360,44,"Frame_00","Selection Extensions for Back-Up",{ 007 ,002 , 204},{ 128,128,255} )       
      
        DEFINE RADIOGROUP Radio_1
               ROW   032
               COL   032
               OPTIONS { ' *.*',' *.Docx ',' *.Xlsx ',' *.Dbf',' *.Pdf',' *.Jpg' }   
               BACKCOLOR {128,128,255}    
               VALUE 1 
               WIDTH 100 
               TOOLTIP 'Selection Extensions' 
               HORIZONTAL .T.
               SPACING 058
               ONCHANGE Change_Radius()
        END RADIOGROUP

*--------------------------------------------------------------------------------------------------*

        MiFrame( 090,020,360,51,"Frame_01","Selection Password",{ 007 ,002 , 204},{ 128,128,255} )     

         DEFINE CHECKBOX Check_1
	        ROW    094
                COL    036
                WIDTH  080  
                HEIGHT 42
                CAPTION SPACE(2)+"Automatic"     
                VALUE .T.  
                FONTNAME "Arial"
                FONTSIZE 9
	        FONTBOLD .T.
	        BACKCOLOR {128,128,255}    
              * FONTCOLOR {128,000,000}
	        TRANSPARENT .F.
                TOOLTIP "PassWord"
                ONCHANGE Num_Pasword()        
         END CHECKBOX

         DEFINE TEXTBOX Text_2
               ROW    103 
               COL    289 
               WIDTH  082
               HEIGHT 22
               FONTNAME "Arial"
               FONTSIZE 9
               TOOLTIP ""
               ONCHANGE nPassManualy()
               ONGOTFOCUS Nil
               ONLOSTFOCUS Nil
               FONTBOLD .F.
               FONTITALIC .F.
               FONTUNDERLINE .F.
               FONTSTRIKEOUT .F.
               ONENTER Nil
               HELPID Nil
               TABSTOP .T.
               VISIBLE .T.
               READONLY .T.
               RIGHTALIGN .F.
               DISABLEDBACKCOLOR  { 218,254,218 } 
               DISABLEDFONTCOLOR  { 000,000,000 } 
               BACKCOLOR  { 218,254,218 } 
               FONTCOLOR  { 000,000,000 } 
               FORMAT  Nil
               INPUTMASK "9999999999"
               VALUE  ALLTRIM( rNum  )  
               MAXLENGTH 10                  
               UPPERCASE .F. 
               LOWERCASE .T. 
         END TEXTBOX

         DEFINE LABEL Lab_002    
                ROW    106
		COL    122  
		WIDTH  167   
		HEIGHT 035
		VALUE  "Password  For -> Un_Zip: "     
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		BACKCOLOR {128,128,255} 
	 END LABEL

*-------------------------------------------------------------------------------*

 	 DEFINE BUTTON Button_1
		ROW 253
		COL 045
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(04)-"&Create Backup"
		ACTION Initius_CreateZip()   
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Create Backup"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Acep1.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_2
		ROW 253
		COL 205
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(02)-"&Recover Backup"
		ACTION  Initius_CreateUnZip()      
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Recover Backup"
                FONTBOLD .T.
                FONTITALIC .T.   
                PICTURE "Resource\Acep2.bmp"     
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_3
		ROW 303
		COL 045
		WIDTH 150
		HEIGHT 32
		CAPTION  SPACE(05)-"&View Zip"
		ACTION  VerBaseZip()
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "View Zip"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Viewx0.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

	 DEFINE BUTTON Button_4
		ROW 303
		COL 205
		WIDTH 150
		HEIGHT 32
		CAPTION SPACE(09)-"&Exit"
		ACTION Form_1.Release
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Exit"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Cancel.bmp"
                PICTALIGNMENT  LEFT
	 END BUTTON

         DEFINE LABEL Title    // View ProgressBar
                ROW  169  
		COL  150 
		WIDTH 350  
		HEIGHT 20
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .F.
	 END LABEL

	 DEFINE PROGRESSBAR ProgressBar_1
		ROW    193
		COL    045
		WIDTH  310
		HEIGHT 022   
		RANGEMIN 0   
		RANGEMAX 100  
		VALUE 0
		FORECOLOR {000,130,000}
	 END PROGRESSBAR

	 DEFINE LABEL Label_1
		ROW    223  
		COL    025
		WIDTH  350
		HEIGHT 020
		VALUE ""
		FONTNAME "Arial"
		FONTSIZE 10
		TOOLTIP ""
		FONTBOLD .T.
		TRANSPARENT .T.
		CENTERALIGN .T.
	 END LABEL

         SETWINDOWCURSOR ( Form_1.Button_4.Handle, "Resource\SmoothHand.cur")  
 
  END WINDOW

  Chane_Style() 
 
  Form_1.Check_1.Value := .F.

  CENTER WINDOW Form_1
  ACTIVATE WINDOW Form_1

RETURN NIL

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*-------------------------------------------------------------------------------------------* 
 FUNCTION Chane_Style()  
*-------------------------------------------------------------------------------------------* 
 
  HMG_ChangeWindowStyle ( GetControlHandle("ProgressBar_1","Form_1"), LVS_REPORT, NIL, .T. )

RETURN NIL

*-------------------------------------------------------------------------------------------*
 FUNCTION   Num_Pasword()
*-------------------------------------------------------------------------------------------*

   Form_1.Text_2.ReadOnly := .T.
   Form_1.Check_1.CAPTION := SPACE(2)+"Automatic" 
 
    aChecboQ  := ( IIF(Form_1.Check_1.Value,"True","False") )
 
    IF aChecboQ = "True"  
      IF  mirgy ==  "0"
          rNum  := pQrix 
          Form_1.Text_2.Value := ALLTRIM( rNum  )  
          Form_1.Check_1.CAPTION := SPACE(2) + "Automatic" 
          Form_1.Text_2.ReadOnly := .T.
          Form_1.Text_2.Value := ALLTRIM( rNum  )   
     ELSE
         rNum  := ALLTRIM( pRova )                 
         Form_1.Text_2.Value := ALLTRIM( rNum  )  
     ENDIF
    ELSE
      rNum := "0000000000"  
      Form_1.Check_1.CAPTION := SPACE(2)+"Manually "
      Form_1.Text_2.ReadOnly := .F.
      Form_1.Text_2.Value := ALLTRIM( rNum  )  
      nPassManualy()
  ENDIF

  hb_gcAll()

RETURN NIL
*------------------------------------------------------------------------------*
Function  nPassManualy()
*------------------------------------------------------------------------------*
  rNum  :=  Form_1.Text_2.Value 

RETURN NIL

*----------------------------------*
FUNCTION Change_Radius()
*----------------------------------*

DO CASE 

CASE Form_1.Radio_1.Value == 0
     Tipx := "*.*"
CASE Form_1.Radio_1.Value == 1
     Tipx := "*.*"
CASE Form_1.Radio_1.Value == 2
     Tipx := "*.Docx"
CASE Form_1.Radio_1.Value == 3
     Tipx := "*.Xlsx" 
CASE Form_1.Radio_1.Value == 4
     Tipx := "*.Dbf"         
CASE Form_1.Radio_1.Value == 5
     Tipx := "*.Pdf"    
CASE Form_1.Radio_1.Value == 6
     Tipx := "*.Jpg"  

ENDCASE

RETURN NIL

*------------------------------------------------------------------------------*
Function Initius_CreateZip()
*------------------------------------------------------------------------------*

 PRIVATE nX

 Form_1.Title.Value   := " " 
 Form_1.Label_1.Value := " " 

 CreateZip() 
   
 For nX := 0 to 100 step 1

    DO EVENTS 

    Form_1.Title.Value := "Progress: " + Str(nX,3)+" %"
    Form_1.ProgressBar_1.Value := nX    
    Form_1.ProgressBar_1.Refresh()   

    MILLISEC(80)   
 
 Next  
 
   MILLISEC( .08) 

   MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}

   Form_1.ProgressBar_1.Value := 0
   Form_1.Title.Value := " "
   Form_1.Label_1.Value := 'Backup is finished'

   Form_1.Radio_1.Value := 1
   Form_1.Check_1.Value := .F.
   Form_1.Text_2.Value  := "0000000000"

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function CreateZip()
*------------------------------------------------------------------------------*

 PRIVATE cFileD := GetFolder () 
 PRIVATE aDir   := Directory( cFileD +"\"+ Tipx , "D"   ) 
 PRIVATE cPath  := cFileD +"\" 
 PRIVATE ficXq  := RIGHT( cFileD , LEN(cFileD) - RAT("\", cFileD ))  
 PRIVATE aFiles := {}
 PRIVATE Date_Copy         
 PRIVATE Nome_Zip    
*-------------------------------------------------------------------------------*
 FDIA    := DTOC(DATE())
 FDIAx   := STRTRAN(FDIA, '/')     && <--------  eliminas la barra(/)
 HORYx   := SUBSTR(TIME(),4,5)     && <-------   hora por detras
 HORy    := STRTRAN( HORYx , ':')  && <--------  eliminas los dos puntos(:)
 HORA    := LEFT(TIME(), 5)        && <-------   hora por delante
 HORAx   := STRTRAN(HORA, ':')     && <--------  eliminas los dos puntos(:)
*-------------------------------------------------------------------------------*
 Typo  :=  Tipx    
 firaax := RIGHT( Typo  , LEN(Typo ) - RAT(".", Typo  ))  
 NuevoT =  LEFT ( firaax , LEN( firaax ) )   
*------------------------------------------------------------------------------------------------------*

 IF  NuevoT = "*"
      Date_Copy :="\" + ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + ".Zip" 
      Nome_Zip  :=      ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + ".Zip"       
  ELSE
      Date_Copy :="\" + ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + ".Zip" 
      Nome_Zip  :=      ficXq +"_"+ ALLTRIM(FDIAx) + "-" + ALLTRIM(HORy) + ".Zip"   
  ENDIF

*------------------------------------------------------------------------------------------------------*

  IF Empty(cFileD )
    	msginfo("Please select Source Folder", "Attenttion !!!")
        MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}
        Form_1.ProgressBar_1.Value := 0
        Form_1.Title.Value := " "
        Form_1.Label_1.Value := 'Backup is finished'
       	Return nil
 ENDIF 
   
 FillFiles( aFiles, aDir, cPath )

 IF ( nLen := Len(aFiles) ) > 0

         MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,000}

   IF  rNum  <> "0000000000"

       	COMPRESS aFiles ;
	       	TO 'Compress_Zip\'+ Date_Copy;
		BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
		LEVEL 9 ;
		PASSWORD ALLTRIM( rNum ) ;
		OVERWRITE ;
		RESULT lSuccess
    ELSE
          COMPRESS aFiles ;
 		TO 'Compress_Zip\'+ Date_Copy;
                 BLOCK  {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;    
                 OVERWRITE
   ENDIF

*------------------------------- Back_Up Control.Dbf -------------------------*    
    CLOSE DATABASES

    DirChange( aDir1W )  

    CLOSE DATABASES
    SELECT 1  
    USE CONTROL 
    APPEND BLANK
    REPLACE CONTROL->DIR_ZIP   WITH cFileD +"\_[ "+  Tipx +" ].Zip"   // Incorpora a la  BaseDatos  la extensión del Zip ejem [ *.jpg]    
    REPLACE CONTROL->NOM_ZIP   WITH Nome_Zip 
 IF rNum <> "0000000000"  
    REPLACE CONTROL->PASSWORD  WITH ALLTRIM( rNum )
 ELSE
    REPLACE CONTROL->PASSWORD  WITH "No_PassW.." 
 ENDIF
  REPLACE CONTROL->DATE_E    WITH DATE()
  REPLACE CONTROL->TIME_E    WITH TIME()
  REPLACE CONTROL->UN_ZIP    WITH .F.
  REPLACE CONTROL->TIME_S    WITH "00:00:00"
 ENDIF

RETURN NIL

*------------------------------------------------------------------------------*
Function Initius_CreateUnZip()
*------------------------------------------------------------------------------*
 PRIVATE nQ

 Form_1.Title.Value   := " " 
 Form_1.Label_1.Value := " " 

 CreateUnZip()

 For nQ  := 0 to 100 step 1

    DO EVENTS 

    Form_1.Title.Value := "Progress: " + Str(nQ,3)+" %"
    Form_1.ProgressBar_1.Value := nQ     
    Form_1.ProgressBar_1.Refresh()   

      MILLISEC(080)  
 
 Next  

   MILLISEC( 1.08) 
  
   MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {000,000,255}
   Form_1.ProgressBar_1.Value := 0
   Form_1.Title.Value := " "
   Form_1.Label_1.Value := 'Backup is finished'
   Form_1.Radio_1.Value := 1

   Form_1.Radio_1.Value := 1
   Form_1.Check_1.Value := .F.
   Form_1.Text_2.Value  := "0000000000"

   RELEASE MEMORY

Return(.T.)

*------------------------------------------------------------------------------*
Function  CreateUnZip()
*------------------------------------------------------------------------------*

PRIVATE cCurDir := GetCurrentFolder(), cArchive, lSuccess
cArchive := Getfile ( { {'Zip Files','*.ZIP'} } , 'Open File' , cCurDir , .F. , .T. )
FicherA  := RIGHT( cArchive , LEN(cArchive) - RAT("\", cArchive ))  

 IF ! HB_DirExists(DirZY)   //  Directorio Destino --> \UnCompress_Zip
      MsgStop( SPACE(4) + cDirQ + CRLF + CRLF + "Directory not Found!","Attenttion !!!" )
      DirMake( DirZY )
      Return (.T.)
 ENDIF 

 IF !Empty(cArchive)
	Form_1.ProgressBar_1.RangeMin := 0
	MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {0,0,0}

     IF hb_ZipWithPassword( cArchive ) 
      *   Msginfo("PasWord Yes")
          Form_1.Check_1.CAPTION := SPACE(2)+"Automatic"
          Form_1.Check_1.Value := .T.
          DirChange( aDir1W )       
          XercaryPass()
          Form_1.ProgressBar_1.RangeMax := 2
              *  Msginfo("Password Yes")
		UNCOMPRESS cArchive ;
			EXTRACTPATH cCurDir + "\UnCompress_Zip" ;    
			BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
			PASSWORD ALLTRIM( rNum ) ;   
			RESULT lSuccess ;
			CREATEDIR

    ELSE
       *  Msginfo("PasWord No")
          Form_1.Check_1.CAPTION := SPACE(2)+"Manually "
          Form_1.Check_1.Value := .F.
          DirChange( aDir1W )     
          XercaryPass()

          Form_1.ProgressBar_1.RangeMax := Len( hb_GetFilesInZip(cArchive) ) - 1
          *     Msginfo("Password No")
		UNCOMPRESS cArchive ;
			EXTRACTPATH cCurDir + "\UnCompress_Zip" ;
			BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
			RESULT lSuccess ;
			CREATEDIR

    ENDIF

      MODIFY CONTROL Label_1 OF Form_1 FONTCOLOR {0,0,255}
      Form_1.Label_1.Value := iif(lSuccess, 'Restoration of Backup is finished', 'Restoration Error')

      CLOSE DATABASES
      SELECT 1  
      USE CONTROL 
      LOCATE FOR NOM_ZIP = ALLTRIM( FicherA ) 
   IF FOUND()
      REPLACE DATE_S   WITH DATE()
      REPLACE TIME_S   WITH TIME()
      REPLACE UN_ZIP   WITH .T.
   ENDIF

 ENDIF

Return Nil

*-----------------------------------------------------------*
FUNCTION XercaryPass()
*-----------------------------------------------------------*

      CLOSE DATABASES
      SELECT 1  
      USE CONTROL 
      LOCATE FOR NOM_ZIP = ALLTRIM( FicherA ) 
   IF FOUND()
      Form_1.Text_2.Value :=  CONTROL->PASSWORD 
   ENDIF
   IF  CONTROL->PASSWORD == "No_PassW.."
       Form_1.Text_2.Value := "0000000000"   
   ENDIF 
   IF passy <>  "0000000000"   
      passy :=  Form_1.Text_2.Value
   ENDIF  
   passy :=  Form_1.Text_2.Value

   cTargetFolder := "UnCompress_Zip"

   IF ! FOUND()
        MsgStop("The Zip file is not in Data Base","Attention !!!")   
        Form_1.Check_1.CAPTION := SPACE(2)+"Manually "
        Form_1.Check_1.Value := .F.
        Form_1.Text_2.ReadOnly := .F.
        Return(.F.)
   
      IF hb_ZipWithPassword(  cArchive ) 
      * Msginfo("PasWord Yes","Manually" )
        Form_1.Check_1.CAPTION := SPACE(2)+"Manually "
        Form_1.Check_1.Value := .F.
        Form_1.Text_2.ReadOnly := .F.
        PassManualy()
        Return
    ENDIF      
ENDIF
  
   DirChange( aDir1W ) 

RETURN NIL

*------------------------------------------------------------------------------*
Function  PassManualy()
*------------------------------------------------------------------------------*
* Form_1.Text_2.Value  := "0000000000"
  passy :=  Form_1.Text_2.Value 
 
RETURN NIL

*------------------------------------------------------------------------------*
Function ProgressUpdate( nPos , cFile , lShowFileName )
*------------------------------------------------------------------------------*
	Default lShowFileName := .F.
	Form_1.Label_1.Value := cFileNoPath( cFile )

	if lShowFileName
		INKEY(.1)
	endif

Return Nil

*------------------------------------------------------------------------------*
Function FillFiles( aFiles, cDir, cPath )
*------------------------------------------------------------------------------*
  PRIVATE aSubDir, cItem

  FOR cItem :=1 TO LEN(cDir)
    IF cDir[cItem][5] <> "D"
      AADD( aFiles, cPath+cDir[cItem][1] )
    ELSEIF cDir[cItem][1] <> "." .AND. cDir[cItem][1] <> ".."
      aSubDir := DIRECTORY( cPath+cDir[cItem][1]+"\*.*" )
      aFiles:=FillFiles( aFiles, aSubdir, cPath+cDir[cItem][1]+"\" )
    ENDIF
  NEXT

Return aFiles

*----------------------------------------------------*
FUNCTION NoEstaDBF()
*----------------------------------------------------*
local aStru:={{"DIR_ZIP"  ,"C",60,0},;
              {"NOM_ZIP"  ,"C",60,0},;
              {"PASSWORD" ,"C",10,0},;
              {"FOLDER"   ,"L", 1,0},;
              {"DATE_E"   ,"D", 8,0},;
              {"TIME_E"   ,"C", 8,0},;
              {"UN_ZIP"   ,"L", 1,0},;
              {"DATE_S"   ,"D", 8,0},;
              {"TIME_S"   ,"C", 8,0}};

         REQUEST DBFCDX

         dbCreate( "Control.dbf", aStru, "DBFCDX", .T. )

  CLOSE DATABASES
  USE CONTROL NEW
  dbAppend()
  DELETE FOR DIR_ZIP = ""
  PACK
  CLOSE DATABASES
  USE CONTROL NEW
  INDEX ON DATE_E TO Segury  
             
RETURN NIL

*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*